'''
BoatViz User Interface for The Bandit Naval warfare RTS game
'''

import wx
from ocean import *
import globals
import scenario
import entity


oceanPanel = None

class ControlPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        sizer = wx.BoxSizer(wx.VERTICAL)


        buttonGrid = wx.GridSizer(4, 2)

        buttonGrid.Add(wx.StaticText(self, label="Player"))
        buttonGrid.Add(wx.StaticText(self, label="Enemy"))

        button = wx.Button(self, label="Aircraft Carrier")
        self.Bind(wx.EVT_BUTTON, oceanPanel.entityAircraftCarrierPlacementA, button)
        buttonGrid.Add(button)

        button = wx.Button(self, label="Aircraft Carrier")
        self.Bind(wx.EVT_BUTTON, oceanPanel.entityAircraftCarrierPlacementB, button)
        buttonGrid.Add(button)

        button = wx.Button(self, label="Destroyer")
        self.Bind(wx.EVT_BUTTON, oceanPanel.entityDestroyerPlacementA, button)
        buttonGrid.Add(button)

        button = wx.Button(self, label="Destroyer")
        self.Bind(wx.EVT_BUTTON, oceanPanel.entityDestroyerPlacementB, button)
        buttonGrid.Add(button)

        button = wx.Button(self, label="Cargo Ship")
        self.Bind(wx.EVT_BUTTON, oceanPanel.entityCargoshipPlacementA, button)
        buttonGrid.Add(button)

        button = wx.Button(self, label="Cargo Ship")
        self.Bind(wx.EVT_BUTTON, oceanPanel.entityCargoshipPlacementB, button)
        buttonGrid.Add(button)

        sizer.Add(buttonGrid)


        self.logWindow = wx.TextCtrl(self, value="Log Window\n", style=wx.TE_MULTILINE, size=(200,
            300))
        sizer.Add(self.logWindow)


        sizer.Add(wx.StaticText(self, label="Time Acceleration"))
        timeAccelSlider = wx.Slider(self, minValue=1.0, maxValue=100.0)
        self.Bind(wx.EVT_SCROLL, self.OnTimeAccel, timeAccelSlider)
        sizer.Add(timeAccelSlider)


        inflMapSizer = wx.BoxSizer(wx.HORIZONTAL)
        inflMapSizer.Add(wx.StaticText(self, label="Influence Maps "))
        inflMapCheckbox = wx.CheckBox(self)
        self.Bind(wx.EVT_CHECKBOX, self.inflMapCheckboxHandler, inflMapCheckbox)
        inflMapSizer.Add(inflMapCheckbox)

        sizer.Add(inflMapSizer)
        

        self.SetSizer(sizer)
        
    def OnTimeAccel(self, event):
        self.logWindow.AppendText("slider %f \n" % (event.GetPosition()/10.0))
        globals.timeAccel = event.GetPosition()/10.0

    def inflMapCheckboxHandler(self, event):
        entity.Entity.drawInfluenceMap = event.GetInt()


    

class BoatVizFrame(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, -1, "BoatViz", size=(800,600))

        sizer = wx.BoxSizer(wx.HORIZONTAL)
        #panel = wx.Panel(self)

        global oceanPanel
        oceanPanel = myGLCanvas(self)

        self.controlPanel = ControlPanel(self)

        self.createMenuBar()

        sizer.Add(oceanPanel, 6, wx.EXPAND)
        sizer.Add(self.controlPanel, 0, wx.EXPAND)

        self.SetSizer(sizer)

        self.Fit()



    def createMenuBar(self):
        menubar = wx.MenuBar()

        fileMenu = wx.Menu()
        exit = fileMenu.Append(wx.NewId(), "E&xit", "")
        self.Bind(wx.EVT_MENU, onExit, exit)
        menubar.Append(fileMenu, "&File")

        settingsMenu = wx.Menu()
        connect = settingsMenu.Append(wx.NewId(), "&Connect")
        self.Bind(wx.EVT_MENU, oceanPanel.entityCargoshipPlacementA, connect)
        menubar.Append(settingsMenu, "&Settings")

        self.SetMenuBar(menubar)





class BoatVizApp(wx.App):

    def __init__(self, redirect=False):
        wx.App.__init__(self, redirect, None)

    def OnInit(self):
        frame = BoatVizFrame(None)
        frame.Show()
        return True


def onExit(event):
        wx.Exit()



globals.scenario = scenario.Scenario('data/island_scenario.dat')
wx.InitAllImageHandlers()
app = BoatVizApp()
app.MainLoop()

