'''
BoatViz User Interface for The Bandit Naval warfare RTS game
'''
import sys

import PythonInterface

class CGameEngine:
    

    def __init__(self):
        self.trace = False
        self.events = []

    def reset(self):
        PythonInterface.reset()
    
    def getPosition(self, name):
        if self.trace: 
            print "def getPosition(self, "+name+"):"
        x, y, z = PythonInterface.getPosition(name)
        return (x, y)

    def getOrientation(self, name):
        if self.trace: print "def getOrientation(self, "+name+"):"
        return PythonInterface.getOrientation(name)

    def getLength(self, name):
        if self.trace: print "def getLength(self, "+name+"):"
        return PythonInterface.getLength(name)

    def getWidth(self, name):
        if self.trace: print "def getWidth(self, "+name+"):"
        return PythonInterface.getWidth(name)

    def getHealth(self, name):
        if self.trace: print "def getHealth(self, "+name+"):"
        return PythonInterface.getHealth(name)*1.0/PythonInterface.getMaxHealth(name)

    def getDestinations(self, name):
        if self.trace: print "def getDestination(self, "+name+"):"
        waypoints =  PythonInterface.getDestinations(name)
        if waypoints == None:
            return None
        else:
            return waypoints

    def setDestination(self, name, x, y, z):
        if self.trace: print "def setDestination(self, "+name+"):"
        PythonInterface.setDestination(name, x, y)

    def addDestination(self, name, x, y, z):
        if self.trace: print "def addDestination(self, "+name+", "+str(x)+", "+str(y)+" ):"
        PythonInterface.addDestination(name, x, y)

    def getTargetPosition(self, name):
        if self.trace: print "def getTargetPosition(self, "+name+"):"
        return None

    def hit(self, name):
        if self.trace: print "def hit(self, "+name+"):"
        pass

    def attack(self, name, target):
        if self.trace: print "def attack(self, "+name+", " +target+"):"
        PythonInterface.attack(name, target)

    def step(self, entityManager):
        if self.trace: print "def step(self):"
        PythonInterface.step()
        for i in entityManager.entities:
            if not self.hasEntity(i.uniquename):
                self.addEvent(("DESTROY_BOAT", i.uniquename))

    def makeCigarette(self, name, x, y, z):
        if self.trace: print "def makeCigarette(self, "+name+", "+str(x)+", "+str(y)+" ):"
        PythonInterface.makeCigarette(name, x, y, z)

    def makeAircraftCarrier(self, name, x, y, z):
        if self.trace: print "def makeAircraftCarrier(self, "+name+", "+str(x)+", "+str(y)+" ):"
        PythonInterface.makeCigarette(name, x, y, z)

    def makeDestroyer(self, name, x, y, z):
        if self.trace: print "def makeDestroyer(self, "+name+", "+str(x)+", "+str(y)+" ):"
        PythonInterface.makeDestroyer(name, x, y, z)

    def makeCargoship(self, name, x, y, z):
        if self.trace: print "def makeCargoship(self, "+name+", "+str(x)+", "+str(y)+" ):"
        PythonInterface.makeCigarette(name, x, y, z)

    def addEvent(self, event):
        if self.trace: print "def addEvent(self, event):"
        self.events.insert(0, event)

    def getEvent(self):
        if self.trace: print "def getEvent(self):"
        if len(self.events) == 0:
            return None
        else:
            return self.events.pop() 
    
    def hasEntity(self, name):
        return PythonInterface.hasEntity(name)

    def hasProjectile(self, entName, projName):
        return PythonInterface.hasProjectile(name)

