import globals
import graphics
import animation

import wx


class Scenario:

    def __init__(self, filename):

        f = open(filename, 'r')
        data = f.readlines()

        self.name = data[1].strip()
        self.terrainTextureFilename = data[3].strip()
        self.terrainTexture = None
        self.terrainInfluenceFilename = data[5].strip()
        self.terrainInfluence = None

        self.terrainWidth = float(data[7])
        self.terrainHeight = float(data[9])

        locations = data[11].split()
        self.playerBoats = []
        for i in range(0, len(locations), 2):
            self.playerBoats.append((int(locations[i]), int(locations[i+1])))

        locations = data[13].split()
        self.enemyBoats = []
        for i in range(0, len(locations), 2):
            self.enemyBoats.append((int(locations[i]), int(locations[i+1])))

        locations = data[15].split()
        self.flagx = int(locations[0])
        self.flagy = int(locations[1])
        self.flagAnimation = None

        self.autoAttack = True
        self.autoMove = True

    def noGraphInitialize(self):
        for i in self.playerBoats:
            globals.entityManager.addDestroyer(1, i[0], i[1])

        for i in self.enemyBoats:
            globals.entityManager.addDestroyer(2, i[0], i[1])

    def initialize(self):
        self.terrainTexture = graphics.Texture2D(self.terrainTextureFilename)
        self.terrainInfluence = wx.Image(self.terrainInfluenceFilename, wx.BITMAP_TYPE_BMP)
        self.flagAnimation = animation.Animation("data/flag_animation.dat", looping=True)

        for i in self.playerBoats:
            entity = globals.entityManager.addDestroyer(1, i[0], i[1])
            entity.initGraphics("data/destroyer.dat", 1)

        for i in self.enemyBoats:
            entity = globals.entityManager.addDestroyer(2, i[0], i[1])
            entity.initGraphics("data/destroyer.dat", 2)

    def draw(self):
        globals.scenario.terrainTexture.draw(globals.scenario.terrainWidth, \
        globals.scenario.terrainHeight, 0, 0)

        self.flagAnimation.draw(300, self.flagx, self.flagy)


